"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findNodeAtOffset = exports.findNodeAtLocation = exports.SwfLanguageService = void 0;
var vscode_languageserver_types_1 = require("vscode-languageserver-types");
var jsonc = require("jsonc-parser");
var path_1 = require("path");
var api_1 = require("@kie-tools/serverless-workflow-service-catalog/dist/api");
var api_2 = require("../api");
var swfModelQueries = require("./modelQueries");
var schemas_1 = require("../schemas");
var vscode_json_languageservice_1 = require("vscode-json-languageservice");
var refValidation_1 = require("./refValidation");
var nodeUpUntilType_1 = require("./nodeUpUntilType");
var findNodesAtLocation_1 = require("./findNodesAtLocation");
var SwfLanguageService = (function () {
    function SwfLanguageService(args) {
        this.args = args;
    }
    SwfLanguageService.prototype.getCompletionItems = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var doc, cursorOffset, currentNode, currentNodePosition, overwriteRange, swfCompletionItemServiceCatalogServices, _a, _b, _c, _d, result;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        if (!args.rootNode) {
                            return [2, []];
                        }
                        doc = vscode_json_languageservice_1.TextDocument.create(args.uri, this.args.lang.fileLanguage, 0, args.content);
                        cursorOffset = doc.offsetAt(args.cursorPosition);
                        currentNode = findNodeAtOffset(args.rootNode, cursorOffset, true);
                        if (!currentNode) {
                            return [2, []];
                        }
                        currentNodePosition = {
                            start: doc.positionAt(currentNode.offset),
                            end: doc.positionAt(currentNode.offset + currentNode.length),
                        };
                        overwriteRange = ["string", "number", "boolean", "null"].includes(currentNode === null || currentNode === void 0 ? void 0 : currentNode.type)
                            ? vscode_languageserver_types_1.Range.create(currentNodePosition.start, currentNodePosition.end)
                            : args.cursorWordRange;
                        _b = (_a = Promise).all;
                        _c = [[]];
                        return [4, this.args.serviceCatalog.global.getServices()];
                    case 1:
                        _d = [__spreadArray.apply(void 0, _c.concat([__read.apply(void 0, [(_e.sent())]), false]))];
                        return [4, this.args.serviceCatalog.relative.getServices(doc)];
                    case 2: return [4, _b.apply(_a, [__spreadArray.apply(void 0, _d.concat([__read.apply(void 0, [(_e.sent())]), false])).map(function (service) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                var _b;
                                var _this = this;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            _a = [__assign({}, service)];
                                            _b = {};
                                            return [4, Promise.all(service.functions.map(function (func) { return __awaiter(_this, void 0, void 0, function () {
                                                    var _a;
                                                    var _b;
                                                    return __generator(this, function (_c) {
                                                        switch (_c.label) {
                                                            case 0:
                                                                _a = [__assign({}, func)];
                                                                _b = {};
                                                                return [4, this.getSwfCompletionItemServiceCatalogFunctionOperation(service, func, doc)];
                                                            case 1: return [2, (__assign.apply(void 0, _a.concat([(_b.operation = _c.sent(), _b)])))];
                                                        }
                                                    });
                                                }); }))];
                                        case 1: return [2, (__assign.apply(void 0, _a.concat([(_b.functions = _c.sent(), _b)])))];
                                    }
                                });
                            }); })])];
                    case 3:
                        swfCompletionItemServiceCatalogServices = _e.sent();
                        return [4, Promise.all(Array.from(completions.entries())
                                .filter(function (_a) {
                                var _b = __read(_a, 2), path = _b[0], _ = _b[1];
                                return args.codeCompletionStrategy.shouldComplete({
                                    root: args.rootNode,
                                    node: currentNode,
                                    path: path,
                                    content: args.content,
                                    cursorOffset: cursorOffset,
                                });
                            })
                                .map(function (_a) {
                                var _b = __read(_a, 2), _ = _b[0], completionItemsDelegate = _b[1];
                                return completionItemsDelegate({
                                    document: doc,
                                    cursorPosition: args.cursorPosition,
                                    currentNode: currentNode,
                                    currentNodePosition: currentNodePosition,
                                    rootNode: args.rootNode,
                                    overwriteRange: overwriteRange,
                                    swfCompletionItemServiceCatalogServices: swfCompletionItemServiceCatalogServices,
                                    langServiceConfig: _this.args.config,
                                    codeCompletionStrategy: args.codeCompletionStrategy,
                                });
                            }))];
                    case 4:
                        result = _e.sent();
                        return [2, Promise.resolve(result.flat())];
                }
            });
        });
    };
    SwfLanguageService.prototype.getDiagnostics = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var textDocument, refValidationResults, schemaValidationResults, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!args.rootNode) {
                            return [2, []];
                        }
                        textDocument = vscode_json_languageservice_1.TextDocument.create(args.uriPath, "serverless-workflow-".concat(this.args.lang.fileLanguage), 1, args.content);
                        refValidationResults = (0, refValidation_1.doRefValidation)({ textDocument: textDocument, rootNode: args.rootNode });
                        if (this.args.lang.fileLanguage === api_2.FileLanguage.YAML) {
                            return [2, refValidationResults];
                        }
                        return [4, this.args.config.shouldIncludeJsonSchemaDiagnostics()];
                    case 1:
                        if (!(_b.sent())) return [3, 3];
                        return [4, this.getJsonSchemaDiagnostics(textDocument)];
                    case 2:
                        _a = _b.sent();
                        return [3, 4];
                    case 3:
                        _a = [];
                        _b.label = 4;
                    case 4:
                        schemaValidationResults = _a;
                        return [2, __spreadArray(__spreadArray([], __read(schemaValidationResults), false), __read(refValidationResults), false)];
                }
            });
        });
    };
    SwfLanguageService.prototype.getJsonSchemaDiagnostics = function (textDocument) {
        return __awaiter(this, void 0, void 0, function () {
            var jsonLs, jsonDocument;
            var _this = this;
            return __generator(this, function (_a) {
                jsonLs = (0, vscode_json_languageservice_1.getLanguageService)({
                    schemaRequestService: function (uri) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (uri === schemas_1.SW_SPEC_WORKFLOW_SCHEMA.$id) {
                                return [2, JSON.stringify(schemas_1.SW_SPEC_WORKFLOW_SCHEMA)];
                            }
                            else {
                                throw new Error("Unable to load schema from '".concat(uri, "'"));
                            }
                            return [2];
                        });
                    }); },
                });
                jsonLs.configure({
                    allowComments: false,
                    schemas: [{ fileMatch: this.args.lang.fileMatch, uri: schemas_1.SW_SPEC_WORKFLOW_SCHEMA.$id }],
                });
                jsonDocument = jsonLs.parseJSONDocument(textDocument);
                return [2, jsonLs.doValidation(textDocument, jsonDocument)];
            });
        });
    };
    SwfLanguageService.prototype.getCodeLenses = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var document, addFunction, setupServiceRegistries, logInServiceRegistries, refreshServiceRegistries, displayRhhccIntegration;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!args.rootNode) {
                            return [2, []];
                        }
                        document = vscode_json_languageservice_1.TextDocument.create(args.uri, this.args.lang.fileLanguage, 0, args.content);
                        addFunction = this.createCodeLenses({
                            document: document,
                            rootNode: args.rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                var newCursorPosition = document.positionAt(node.offset + 1);
                                return [
                                    {
                                        name: "swf.ls.commands.OpenFunctionsCompletionItems",
                                        title: "+ Add function...",
                                        args: [
                                            { newCursorPosition: newCursorPosition },
                                        ],
                                    },
                                ];
                            },
                        });
                        setupServiceRegistries = this.createCodeLenses({
                            document: document,
                            rootNode: args.rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                if (!_this.args.config.shouldConfigureServiceRegistries()) {
                                    return [];
                                }
                                return [
                                    {
                                        name: "swf.ls.commands.OpenServiceRegistriesConfig",
                                        title: "↪ Setup Service Registries...",
                                        args: [{ position: position }],
                                    },
                                ];
                            },
                        });
                        logInServiceRegistries = this.createCodeLenses({
                            document: document,
                            rootNode: args.rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                if (_this.args.config.shouldConfigureServiceRegistries()) {
                                    return [];
                                }
                                if (!_this.args.config.shouldServiceRegistriesLogIn()) {
                                    return [];
                                }
                                return [
                                    {
                                        name: "swf.ls.commands.LogInServiceRegistries",
                                        title: "↪ Log in Service Registries...",
                                        args: [{ position: position }],
                                    },
                                ];
                            },
                        });
                        refreshServiceRegistries = this.createCodeLenses({
                            document: document,
                            rootNode: args.rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                if (_this.args.config.shouldConfigureServiceRegistries()) {
                                    return [];
                                }
                                if (!_this.args.config.canRefreshServices()) {
                                    return [];
                                }
                                return [
                                    {
                                        name: "swf.ls.commands.RefreshServiceRegistries",
                                        title: "↺ Refresh Service Registries...",
                                        args: [{ position: position }],
                                    },
                                ];
                            },
                        });
                        return [4, this.args.config.shouldDisplayServiceRegistriesIntegration()];
                    case 1:
                        displayRhhccIntegration = _a.sent();
                        return [2, __spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read((displayRhhccIntegration ? setupServiceRegistries : [])), false), __read((displayRhhccIntegration ? logInServiceRegistries : [])), false), __read((displayRhhccIntegration ? refreshServiceRegistries : [])), false), __read(addFunction), false)];
                }
            });
        });
    };
    SwfLanguageService.prototype.dispose = function () {
    };
    SwfLanguageService.prototype.getSwfCompletionItemServiceCatalogFunctionOperation = function (containingService, func, document) {
        return __awaiter(this, void 0, void 0, function () {
            var specsDirRelativePosixPath, serviceFileName, serviceFileRelativePosixPath, serviceFileName, serviceFileRelativePosixPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.args.config.getSpecsDirPosixPaths(document)];
                    case 1:
                        specsDirRelativePosixPath = (_a.sent()).specsDirRelativePosixPath;
                        if (!(func.source.type === api_1.SwfServiceCatalogFunctionSourceType.LOCAL_FS)) return [3, 2];
                        serviceFileName = path_1.posix.basename(func.source.serviceFileAbsolutePath);
                        serviceFileRelativePosixPath = path_1.posix.join(specsDirRelativePosixPath, serviceFileName);
                        return [2, "".concat(serviceFileRelativePosixPath, "#").concat(func.name)];
                    case 2: return [4, this.args.config.shouldReferenceServiceRegistryFunctionsWithUrls()];
                    case 3:
                        if (!((_a.sent()) &&
                            containingService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY &&
                            func.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY)) return [3, 4];
                        return [2, "".concat(containingService.source.url, "#").concat(func.name)];
                    case 4:
                        if (!(containingService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY &&
                            func.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY)) return [3, 6];
                        return [4, this.args.serviceCatalog.getServiceFileNameFromSwfServiceCatalogServiceId(containingService.source.registry, containingService.source.id)];
                    case 5:
                        serviceFileName = _a.sent();
                        serviceFileRelativePosixPath = path_1.posix.join(specsDirRelativePosixPath, serviceFileName);
                        return [2, "".concat(serviceFileRelativePosixPath, "#").concat(func.name)];
                    case 6: throw new Error("Unknown Service Catalog function source type");
                }
            });
        });
    };
    SwfLanguageService.prototype.createCodeLenses = function (args) {
        var nodes = (0, findNodesAtLocation_1.findNodesAtLocation)(args.rootNode, args.jsonPath);
        var codeLenses = nodes.flatMap(function (node) {
            var _a, _b;
            var position = args.positionLensAt === "end" &&
                (node.type === "object" || node.type === "array") &&
                ((_b = (_a = node.children) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0
                ? args.document.positionAt(node.offset + node.length)
                : args.document.positionAt(node.offset);
            return args.commandDelegates({ position: position, node: node }).map(function (command) { return ({
                command: {
                    command: command.name,
                    title: command.title,
                    arguments: command.args,
                },
                range: {
                    start: position,
                    end: position,
                },
            }); });
        });
        return codeLenses;
    };
    return SwfLanguageService;
}());
exports.SwfLanguageService = SwfLanguageService;
var completions = new Map([
    [
        ["functions", "*"],
        function (_a) {
            var currentNode = _a.currentNode, rootNode = _a.rootNode, overwriteRange = _a.overwriteRange, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices, document = _a.document, langServiceConfig = _a.langServiceConfig, codeCompletionStrategy = _a.codeCompletionStrategy;
            return __awaiter(void 0, void 0, void 0, function () {
                var separator, existingFunctionOperations, specsDir, result;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            separator = currentNode.type === "object" ? "," : "";
                            existingFunctionOperations = swfModelQueries.getFunctions(rootNode).map(function (f) { return f.operation; });
                            return [4, langServiceConfig.getSpecsDirPosixPaths(document)];
                        case 1:
                            specsDir = _b.sent();
                            result = swfCompletionItemServiceCatalogServices.flatMap(function (swfServiceCatalogService) {
                                return swfServiceCatalogService.functions
                                    .filter(function (swfServiceCatalogFunc) { return !existingFunctionOperations.includes(swfServiceCatalogFunc.operation); })
                                    .map(function (swfServiceCatalogFunc) {
                                    var swfFunction = {
                                        name: "${1:".concat(swfServiceCatalogFunc.name, "}"),
                                        operation: swfServiceCatalogFunc.operation,
                                        type: swfServiceCatalogFunc.type,
                                    };
                                    var command = {
                                        name: "swf.ls.commands.ImportFunctionFromCompletionItem",
                                        args: {
                                            containingService: swfServiceCatalogService,
                                            documentUri: document.uri,
                                        },
                                    };
                                    var kind = swfServiceCatalogFunc.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY
                                        ? vscode_languageserver_types_1.CompletionItemKind.Interface
                                        : vscode_languageserver_types_1.CompletionItemKind.Reference;
                                    return {
                                        kind: kind,
                                        label: toCompletionItemLabelPrefix(swfServiceCatalogFunc, specsDir.specsDirRelativePosixPath),
                                        detail: swfServiceCatalogService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY
                                            ? swfServiceCatalogService.source.url
                                            : swfServiceCatalogFunc.operation,
                                        textEdit: {
                                            newText: codeCompletionStrategy.translate(swfFunction) + separator,
                                            range: overwriteRange,
                                        },
                                        snippet: true,
                                        insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                                        command: {
                                            command: command.name,
                                            title: "Import function from completion item",
                                            arguments: [command.args],
                                        },
                                    };
                                });
                            });
                            return [2, Promise.resolve(result)];
                    }
                });
            });
        },
    ],
    [
        ["functions", "*", "operation"],
        function (_a) {
            var _b, _c, _d;
            var currentNode = _a.currentNode, rootNode = _a.rootNode, overwriteRange = _a.overwriteRange, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices, codeCompletionStrategy = _a.codeCompletionStrategy;
            if (!((_b = currentNode.parent) === null || _b === void 0 ? void 0 : _b.parent)) {
                return Promise.resolve([]);
            }
            var isRestFunction = ((_d = (_c = findNodeAtLocation(currentNode.parent.parent, ["type"])) === null || _c === void 0 ? void 0 : _c.value) !== null && _d !== void 0 ? _d : "rest") === "rest";
            if (!isRestFunction) {
                return Promise.resolve([]);
            }
            var existingFunctionOperations = swfModelQueries.getFunctions(rootNode).map(function (f) { return f.operation; });
            var result = swfCompletionItemServiceCatalogServices
                .flatMap(function (s) { return s.functions; })
                .filter(function (swfServiceCatalogFunc) { return !existingFunctionOperations.includes(swfServiceCatalogFunc.operation); })
                .map(function (swfServiceCatalogFunc) {
                var kind = swfServiceCatalogFunc.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY
                    ? vscode_languageserver_types_1.CompletionItemKind.Function
                    : vscode_languageserver_types_1.CompletionItemKind.Folder;
                return {
                    kind: kind,
                    label: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                    detail: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                    filterText: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                    textEdit: {
                        newText: codeCompletionStrategy.translate("".concat(swfServiceCatalogFunc.operation)),
                        range: overwriteRange,
                    },
                    insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                };
            });
            return Promise.resolve(result);
        },
    ],
    [
        ["states", "*", "actions", "*", "functionRef"],
        function (_a) {
            var overwriteRange = _a.overwriteRange, currentNode = _a.currentNode, rootNode = _a.rootNode, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices, codeCompletionStrategy = _a.codeCompletionStrategy;
            if (currentNode.type !== "property") {
                console.debug("Cannot autocomplete: functionRef should be a property.");
                return Promise.resolve([]);
            }
            var result = swfModelQueries.getFunctions(rootNode).flatMap(function (swfFunction) {
                var swfServiceCatalogFunc = swfCompletionItemServiceCatalogServices
                    .flatMap(function (f) { return f.functions; })
                    .filter(function (f) { return f.operation === swfFunction.operation; })
                    .pop();
                if (!swfServiceCatalogFunc) {
                    return [];
                }
                var argIndex = 1;
                var swfFunctionRefArgs = {};
                Object.keys(swfServiceCatalogFunc.arguments).forEach(function (argName) {
                    swfFunctionRefArgs[argName] = "${".concat(argIndex++, ":}");
                });
                var swfFunctionRef = {
                    refName: swfFunction.name,
                    arguments: swfFunctionRefArgs,
                };
                return [
                    {
                        kind: vscode_languageserver_types_1.CompletionItemKind.Module,
                        label: "".concat(swfFunctionRef.refName),
                        sortText: "".concat(swfFunctionRef.refName),
                        detail: "".concat(swfServiceCatalogFunc.operation),
                        textEdit: {
                            newText: codeCompletionStrategy.translate(swfFunctionRef),
                            range: overwriteRange,
                        },
                        insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                    },
                ];
            });
            return Promise.resolve(result);
        },
    ],
    [
        ["states", "*", "actions", "*", "functionRef", "refName"],
        function (_a) {
            var overwriteRange = _a.overwriteRange, rootNode = _a.rootNode, codeCompletionStrategy = _a.codeCompletionStrategy;
            var result = swfModelQueries.getFunctions(rootNode).flatMap(function (swfFunction) {
                return [
                    {
                        kind: vscode_languageserver_types_1.CompletionItemKind.Value,
                        label: "\"".concat(swfFunction.name, "\""),
                        sortText: "\"".concat(swfFunction.name, "\""),
                        detail: "\"".concat(swfFunction.name, "\""),
                        filterText: "\"".concat(swfFunction.name, "\""),
                        textEdit: {
                            newText: codeCompletionStrategy.translate("".concat(swfFunction.name)),
                            range: overwriteRange,
                        },
                        insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                    },
                ];
            });
            return Promise.resolve(result);
        },
    ],
    [
        ["states", "*", "actions", "*", "functionRef", "arguments"],
        function (_a) {
            var _b, _c;
            var overwriteRange = _a.overwriteRange, currentNode = _a.currentNode, rootNode = _a.rootNode, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices, codeCompletionStrategy = _a.codeCompletionStrategy;
            if (currentNode.type !== "property" && currentNode.type !== "string") {
                console.debug("Cannot autocomplete: arguments should be a property.");
                return Promise.resolve([]);
            }
            var startNode = (0, nodeUpUntilType_1.nodeUpUntilType)(currentNode, "object");
            if (!startNode) {
                return Promise.resolve([]);
            }
            var swfFunctionRefName = (_b = findNodeAtLocation(startNode, ["refName"])) === null || _b === void 0 ? void 0 : _b.value;
            if (!swfFunctionRefName) {
                return Promise.resolve([]);
            }
            var swfFunction = (_c = swfModelQueries
                .getFunctions(rootNode)) === null || _c === void 0 ? void 0 : _c.filter(function (f) { return f.name === swfFunctionRefName; }).pop();
            if (!swfFunction) {
                return Promise.resolve([]);
            }
            var swfServiceCatalogFunc = swfCompletionItemServiceCatalogServices
                .flatMap(function (f) { return f.functions; })
                .filter(function (f) { return f.operation === swfFunction.operation; })
                .pop();
            if (!swfServiceCatalogFunc) {
                return Promise.resolve([]);
            }
            var argIndex = 1;
            var swfFunctionRefArgs = {};
            Object.keys(swfServiceCatalogFunc.arguments).forEach(function (argName) {
                swfFunctionRefArgs[argName] = "${".concat(argIndex++, ":}");
            });
            return Promise.resolve([
                {
                    kind: vscode_languageserver_types_1.CompletionItemKind.Module,
                    label: "'".concat(swfFunctionRefName, "' arguments"),
                    sortText: "".concat(swfFunctionRefName, " arguments"),
                    detail: swfFunction.operation,
                    textEdit: {
                        newText: codeCompletionStrategy.translate(swfFunctionRefArgs),
                        range: overwriteRange,
                    },
                    insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                },
            ]);
        },
    ],
]);
function toCompletionItemLabelPrefix(swfServiceCatalogFunction, specsDirRelativePosixPath) {
    var _a;
    switch (swfServiceCatalogFunction.source.type) {
        case api_1.SwfServiceCatalogFunctionSourceType.LOCAL_FS:
            var fileName = (_a = swfServiceCatalogFunction.source.serviceFileAbsolutePath.split("/").pop()) !== null && _a !== void 0 ? _a : swfServiceCatalogFunction.source.serviceFileAbsolutePath;
            return toCompletionItemLabel(specsDirRelativePosixPath, fileName, swfServiceCatalogFunction.name);
        case api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY:
            return toCompletionItemLabel(swfServiceCatalogFunction.source.registry, swfServiceCatalogFunction.source.serviceId, swfServiceCatalogFunction.name);
        default:
            return "";
    }
}
function findNodeAtLocation(root, path) {
    return (0, findNodesAtLocation_1.findNodesAtLocation)(root, path)[0];
}
exports.findNodeAtLocation = findNodeAtLocation;
function findNodeAtOffset(root, offset, includeRightBound) {
    return jsonc.findNodeAtOffset(root, offset, includeRightBound);
}
exports.findNodeAtOffset = findNodeAtOffset;
function toCompletionItemLabel(namespace, resource, operation) {
    return "".concat(namespace, "\u00BB").concat(resource, "#").concat(operation);
}
//# sourceMappingURL=SwfLanguageService.js.map