import { CodeLens, CompletionItem, Position, Range } from "vscode-languageserver-types";
import { SwfLanguageServiceArgs } from "./SwfLanguageService";
import { SwfLsNode } from "./types";
export declare class SwfYamlLanguageService {
    private readonly ls;
    private readonly codeCompletionStrategy;
    constructor(args: Omit<SwfLanguageServiceArgs, "lang">);
    parseContent(content: string): SwfLsNode | undefined;
    getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    getCodeLenses(args: {
        content: string;
        uri: string;
    }): Promise<CodeLens[]>;
    getDiagnostics(args: {
        content: string;
        uriPath: string;
    }): Promise<import("vscode-languageserver-types").Diagnostic[]>;
    dispose(): void;
}
//# sourceMappingURL=SwfYamlLanguageService.d.ts.map