"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.matchNodeWithLocation = void 0;
var nodeUpUntilType_1 = require("./nodeUpUntilType");
var findNodesAtLocation_1 = require("./findNodesAtLocation");
function matchNodeWithLocation(root, node, path) {
    if (!root || !node || !path || !path.length) {
        return false;
    }
    var nodesAtLocation = (0, findNodesAtLocation_1.findNodesAtLocation)(root, path);
    var nodeToMatch = (0, nodeUpUntilType_1.nodeUpUntilType)(node, "object");
    var starSelector = path[path.length - 1] === "*";
    if (starSelector && node.type === "array" && (node === null || node === void 0 ? void 0 : node.children)) {
        return matchNodeWithLocation(root, node, path.slice(0, -1));
    }
    return nodesAtLocation.some(function (currentNode) { return (starSelector && currentNode === nodeToMatch) || (!starSelector && currentNode === node); });
}
exports.matchNodeWithLocation = matchNodeWithLocation;
//# sourceMappingURL=matchNodeWithLocation.js.map