export declare type SwfJsonPath = (string | number)[];
export declare type SwfLsNodeType = "object" | "array" | "property" | "string" | "number" | "boolean" | "null";
export declare type SwfLsNode = {
    type: SwfLsNodeType;
    value?: any;
    offset: number;
    length: number;
    colonOffset?: number;
    parent?: SwfLsNode;
    children?: SwfLsNode[];
};
export interface ShouldCompleteArgs {
    root: SwfLsNode | undefined;
    node: SwfLsNode | undefined;
    path: SwfJsonPath;
    content: string;
    cursorOffset: number;
}
export interface CodeCompletionStrategy {
    translate(completion: object | string): string;
    shouldComplete(args: ShouldCompleteArgs): boolean;
}
//# sourceMappingURL=types.d.ts.map