"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwfYamlOffsets = void 0;
var yaml_language_server_parser_1 = require("yaml-language-server-parser");
var SwfOffsetsApi_1 = require("../api/SwfOffsetsApi");
var astTransformQuery = "mappings[key.value=\"states\"].value.items{\n    \"states\":{\n        mappings[key.value=\"name\"].value.value:{\n            \"stateNameOffset\":startPosition,\n            \"offset\": {\n                \"start\":startPosition,\n                \"end\":endPosition\n            }\n        }\n    }\n}\n";
var SwfYamlOffsets = (function (_super) {
    __extends(SwfYamlOffsets, _super);
    function SwfYamlOffsets(documentUri) {
        return _super.call(this, astTransformQuery, documentUri) || this;
    }
    SwfYamlOffsets.prototype.getFullAST = function () {
        var errorLogMsg = function (message) { return "Received an exeption parsing the content: ".concat(message); };
        if (!this.fullText) {
            return null;
        }
        try {
            var ast = (0, yaml_language_server_parser_1.load)(this.fullText);
            if (ast.errors && ast.errors.length) {
                console.error(errorLogMsg(ast.errors[0].message));
                return null;
            }
            return ast;
        }
        catch (e) {
            console.error(errorLogMsg(e.message));
            return null;
        }
    };
    return SwfYamlOffsets;
}(SwfOffsetsApi_1.SwfOffsetsApi));
exports.SwfYamlOffsets = SwfYamlOffsets;
//# sourceMappingURL=SwfYamlOffsets.js.map